ip link: add VLAN support
[oweals/busybox.git] / testsuite / runtest
index 3ff4b96dab64a3e936aa543b238d2e6cefaca1ad..51575d9260b2e3935c837cd4da5d37468076010d 100755 (executable)
@@ -4,6 +4,8 @@
 
 . ./testing.sh
 
+total_failed=0
+
 # Run one old-style test.
 # Tests are stored in applet/testcase shell scripts.
 # They are run using "sh -x -e applet/testcase".
@@ -26,10 +28,12 @@ run_applet_testcase()
        if grep "^# FEATURE: " "$testcase" >/dev/null; then
                local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
 
-               if grep "^# $feature is not set$" "$bindir/.config" >/dev/null; then
-                       echo "UNTESTED: $testname"
-                       return 0
-               fi
+               for f in $feature; do
+                       if grep "^# $f is not set$" "$bindir/.config" >/dev/null; then
+                               echo "UNTESTED: $testname"
+                               return 0
+                       fi
+               done
        fi
 
        rm -rf ".tmpdir.$applet"
@@ -70,7 +74,10 @@ run_oldstyle_applet_tests()
                        *.mine) continue ;;    # svn-produced junk
                        *.r[0-9]*) continue ;; # svn-produced junk
                esac
-               run_applet_testcase "$applet" "$testcase" || status=1
+               run_applet_testcase "$applet" "$testcase" || {
+                       status=1
+                       total_failed=$((total_failed + 1))
+               }
        done
        return $status
 }
@@ -78,9 +85,10 @@ run_oldstyle_applet_tests()
 
 
 lcwd=$(pwd)
-[ x"$tsdir" != x ] || tsdir="$lcwd"
-[ x"$bindir" != x ] || bindir="${lcwd%/*}" # one directory up from $lcwd
+[ x"$tsdir" != x"" ] || tsdir="$lcwd"
+[ x"$bindir" != x"" ] || bindir="${lcwd%/*}" # one directory up from $lcwd
 PATH="$bindir:$PATH"
+export bindir   # some tests need to look at $bindir/.config
 
 if [ x"$VERBOSE" = x ]; then
        export VERBOSE=
@@ -92,6 +100,7 @@ if [ x"$1" = x"-v" ]; then
 fi
 
 implemented=$(
+       printf "busybox " # always implemented
        "$bindir/busybox" 2>&1 |
        while read line; do
                if [ x"$line" = x"Currently defined functions:" ]; then
@@ -126,7 +135,7 @@ done
 export OPTIONFLAGS=:$(
        sed -nr 's/^CONFIG_//p' "$bindir/.config" |
        sed 's/=.*//' | xargs | sed 's/ /:/g'
-       )
+       ):
 
 status=0
 for applet in $applets; do
@@ -146,7 +155,10 @@ for applet in $applets; do
                fi
 #              echo "Running test $tsdir/$applet.tests"
                PATH="$LINKSDIR:$tsdir:$bindir:$PATH" \
-                       "$tsdir/$applet.tests" || status=1
+                       "$tsdir/$applet.tests"
+               rc=$?
+               total_failed=$((total_failed + rc))
+               test $rc -ne 0 && status=1
        fi
 done
 
@@ -154,6 +166,6 @@ done
 #rm -rf "$LINKSDIR"
 
 if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
-       echo "Failures detected, running with -v (verbose) will give more info"
+       echo "$total_failed failure(s) detected; running with -v (verbose) will give more info"
 fi
 exit $status